<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>FontFlow</title>
    <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
    <style>
        #boxOne {
            font-size: 70px;
            width: 2000px;
            height: 100px;
            color: red;
            position: absolute;
            left: 0px;
            top: 50px;
            overflow: hidden;
        }
        #boxTwo {
            font-size: 70px;
            width: 2000px;
            height: 100px;
            color: blue;
            position: absolute;
            left: 2000px;
            top: 50px;
            overflow: hidden;
        }
        #draggableBox {
            width: 150px;
            height: 150px;
            border: 1px solid blueviolet;
            background-color: blueviolet;
            position: absolute;
            left: 50px;
            top: 150px;
        }
    </style>
</head>
<!-- 아래 스크롤바를 숨긴다. -->
<body style="overflow: hidden;">
    <div id="draggableBox"></div>

    <div id="boxOne">JavaScript Web Developers TCP/IP HTTP gitlab.com DataBase System programming Operating System</div>
    <div id="boxTwo">JavaScript Web Developers TCP/IP HTTP gitlab.com DataBase System programming Operating System</div>

    <script>
        // 요소를 가져오려 호출하면 문서 전체를 확인하므로 처리속도 개선을 위해 변수로 받아
        // 한번만 찾아오고 그것으로 나머지는 참조하는 방식으로 속도를 개선한다.
        var el = $("#draggableBox");
        // attr 메서드로 html 속성에 접근하는 방식보다 변수로 메모리에 넣어 사용하는 것이 좋다.
        // 드레깅 변수를 선언하고 false를 할당하여 사용한다.
        var isDragging = false;
        // 아래 clientX, clientY를 attr 메서드로 접근하지 않고 메모리에 변수로 넣어 둔다.
        var x, y;

        // 상자에서 마우스 왼쪽 버튼이 눌렸을 때 event 함수를 호출하며 그때 event 객체를 인자로 받는다.
        el.on("mousedown", function( ev ) {
            // 드레깅 중이라고 표시한다.
            isDragging = true;
            // 인자로 받은 event 객체를 보면 클릭한 위치 clientX와 clientY를 확인할 수 있다.
            // console.log(ev);
            // clientX, Y로 마우스가 눌렸을때 위치를 기억한다. 마우스가 이동하면 변한 위치의 변화량을 알 수 있다.
            x = ev.clientX;
            y = ev.clientY;
        
        });
        // 상자에서 마우스가 이동 했을 때
        el.on("mousemove", function( ev ) {
            // 현재 드래그 중인지 확인을 변수를 바라본다.
            if ( isDragging ) {
                // 마우스 커서의 이동량을 구해야 한다.
                var deltaX = ev.clientX - x;  // 변수로 메모리에서 x, y를 받아 오므로 
                var deltaY = ev.clientY - y;  // parseInt()를 사용하지 않아도 된다.
                
                // 마우스의 이동량만큼 박스의 lefg, top을 옮긴다.
                var newX = parseInt(el.css("left")) + deltaX;
                var newY = parseInt(el.css("top")) + deltaY;
                el.css({left:newX + "px", top: newY + "px"});

                // 이동후 마우스의 현재위치를 기록한다. 또 마우스가 이동하면 변한 위치의 변화량을 알기위해
                x = ev.clientX;
                y = ev.clientY;
            }

        });
        // 상자에서 마우스 왼쪽 버튼이 때어졌을 때
        el.on("mouseup", function() {
            // 드레깅 끝이라고 표시한다.
            isDragging = false;

        });
        
        // 무한 스크롤
        var timer = setInterval( function() {
            // id boxOne의 css 속성 left를 값을 가져와 할당
            var boxOneCurrentLeft = parseInt($("#boxOne").css("left"));
            boxOneCurrentLeft -= 2;  // 2px씩 계속 감소하여 이동하게 된다.
            $("#boxOne").css("left", boxOneCurrentLeft + "px");

            // id boxTwo의 css 속성 left를 값을 가져와 할당
            var boxTwoCurrentLeft = parseInt($("#boxTwo").css("left"));
            boxTwoCurrentLeft -= 2;  // 2px씩 계속 감소하여 이동하게 된다.
            $("#boxTwo").css("left", boxTwoCurrentLeft + "px");

            // boxOne, boxTwo 둘 중하나가 left가 0이 되면 애니메이션을 멈춘다.
            if ( boxOneCurrentLeft == 0 ) {
                // boxOne의 left가 0이면 boxTwo가 화면밖 왼쪽에 있으므로 boxTwo를 오른쪽 끝으로 옮긴다.
                $("#boxTwo").css("left", "2000px");
            };
            if ( boxTwoCurrentLeft == 0 ) {
                // boxTwo의 left가 0이면 boxOne이 화면밖 왼쪽에 있으므로 boxOne를 오른쪽 끝으로 옮긴다.
                $("#boxOne").css("left", "2000px");
            };

        }, 1000/60 );  // 초당 60회 반복하게 한다.
        
    </script>
</body>
</html>